Beamlib: Beam system library of C++ classes
===========================================

This directory contains the source code for the Beamlib system library of C++ classes.

The Beamlib C++ class library provides a system portable base library for developing real-time and other applications with multi-processor and multi-host support.
It was initially started in the late 1980?s to add Smalltalk like constructions/components to the emerging C++ language for use within Beam for real-time data processing and embedded system uses. Over the years it has been extended as needed to support wildly differing projects.

- Simple Object Orientated development.
- Simple class library for Strings, Lists, Arrays, Dictionaries, Network access etc.
- Support for multi-threaded applications with Mutex Objects etc.
- Usable from C++ and Python with wrapper.
- IDL based object creation tool allows easy creation of C++ and Python objects from IDL language with RPC access across networks.
- IDL provides the ability to create SQL database schema automatically.
- Database access that allows Objects to be stored.
- BOAP (Beam Object Access Protocol) provides a simple, low overhead protocol, that allows access to remote objects using an RPC mechanism.
- Database access via a layer that allows simultaineous access to different database systems including MYSQL and BEAM BDEV native object database.
- Simple HTTP/HTML WEB service support for application embedding.

Please see the documentation in the doc directory.

The Beamlib class library can be installed from the following RPM packages:

- beamlib-lib: Runtime shared libraries.
- beamlib-utils: Runtime tools.
- beamlib-devel: Development include files and shared and static libraries.
- beamlib-doc: Documentation.

License
=======
For the software license see the LICENSE.txt file in this directory.
